#include "ti86asm.inc"

.org _asm_exec_ram

;Source code to Fishswim for TI-86
;by Bradford Wilson

						;makes two fish move across the screen

 call _clrScrn			;clears the screen
 call _homeup			;puts the cursor in the upper left
 ld b,16				;sets the loop counter to 16
 ld c,0					;sets c with 0
loop:
 ld hl,fish				;stores fish to hl
 ld de,$0000			;stores de(this will represent where fish is displayed)
 ld e,c					;adds e and c and stores it in c
 call GridPutSprite		;displays fish at de

 ld hl, backfish		;stores backfish to hl
 ld de,$010f			;stores de with $010f
 push af				;pushes af onto the stack
 ld a,15				;stores 15 to a
 sub c					;subtracts c from a and stores it in a
 ld e,a					;adds e with a and stores thhe result in a
 pop af					;pops af off the stack
 call GridPutSprite		;displays backfish

 call delayloop			;runs delayloop(this will make the fish move slower so you can see it)
 call delayloop			;runs delayloop
 call delayloop			;runs delayloop
 call delayloop			;runs delayloop
 call delayloop			;runs delayloop(its ok, I made 5 because one didn't slow it down enough)
 ld hl,delay			;stores delay to hl
 ld de,$0000			;stores de with $0000
 ld e,c					;adds e with c and
 call GridPutSprite		;covers up the first fish to make it appear like it moves
 ld hl,delay			;loads hl with delay
 ld de,$010f			;stores $010f to de
 push af				;pushes af onto the stack
 ld a,15				;stores 15 to a
 sub c					;subtracts c from a and stores it in a
 ld e,a					;adds e and a and stores it in e
 pop af					;pops af off of the top of the stack
 call GridPutSprite		;covers up the backwards fish to make it appear like its moving
 inc c					;adds 1 to c
 djnz loop				;decreases b and jumps to loop if b is not equal to 0

 
 
 call _pause			;pauses the calculator
 call _clrScrn			;clears the screen
 call _homeup			;puts the cursor in the upper left
 ret					;returns from the program to where you were

GridPutSprite:			;This is the label that is called to draw the picture (a sprite is also a picture)
  push hl         		;This pushes register hl onto the stack
  pop ix                ;This pops whats on the stack (formerly what was in hl) into register ix
  srl d                 ;de = (128 * y) + x
  rra                   ;carry flag -< msb of a
  and $80               ;a is either $00 or $80   
  or e                  ;add x offset (remember x <= 15)
  ld e,a                ;de = (128 * y) + (x * 8)
  ld hl,$fc00           ;This loads hl with the video memory
  add hl,de             ;This loads hl with the video memory + offset
  ld b,8                ;This sets the loop counter to 8
  ld de,16              ;This is because the screen is 16 bytes wide
GPS_Loop:				;This is the loop part
  ld a,(ix + 0)         ;This gets the byte from sprite
  ld (hl),a             ;This puts the byte on screen
  inc ix                ;This moves to next byte in sprite
  add hl,de             ;This moves to next line on screen
  djnz GPS_Loop         ;This decreases the loop counter so it will loop until the sprite is drawn
  ret                   ;This returns to where in the program it was

 
delayloop:
 push bc				;pushes bc onto the stack
 ld b,255				;loads b with 255
delay1:
 ld hl,delay			;stores delay in hl
 ld de,$070f			;stores de with $070f
 call GridPutSprite		;displays delay in the bottom right
 djnz delay1			;jumps to delay 1 until it is done
 pop bc					;pops bc off of the stack
 ret					;returns

;This is where the pictures are stored

fish:					;picture of fish
.db %00000000			;This is part of the picture
.db %00001100			;This is part of the picture
.db %01011110			;This is part of the picture
.db %01111111			;This is part of the picture
.db %01111111			;This is part of the picture
.db %01011110			;This is part of the picture
.db %00001100			;This is part of the picture
.db %00000000			;This is part of the picture



delay:					;blank picture (to cover up each sqaure when the fish moves)
.db %00000000			;This is part of the picture
.db %00000000			;This is part of the picture
.db %00000000			;This is part of the picture
.db %00000000			;This is part of the picture
.db %00000000			;This is part of the picture
.db %00000000			;This is part of the picture
.db %00000000			;This is part of the picture
.db %00000000			;This is part of the picture

backfish:				;backwards fish
.db %00000000			;This is part of the picture
.db %00110000			;This is part of the picture
.db %01111010			;This is part of the picture
.db %11111110			;This is part of the picture
.db %11111110			;This is part of the picture
.db %01111010			;This is part of the picture
.db %00110000			;This is part of the picture
.db %00000000			;This is part of the picture

.end					;this tells the assembler that this is the end